BITS 32

; Code under WTFPL, do what the fuck you want with this code
; File written by aaSSfxxx

; user32.dll imports
extern MessageBoxA
extern MessageBoxW
extern GetDesktopWindow

; kernel32.dll imports
extern ExitProcess
extern wsprintfW

; ole32.dll imports
extern CoInitialize
extern CoCreateInstance

; common win32 constants (header file downloadeable in the Internet)
%include "win32n.inc"

; Some declarations of vtables
%include "COMHelper.inc"

; Macro to shorten error messages typing
%macro ErrMsg 1
push MB_ICONERROR
push error_title
push %1
push 0
call MessageBoxA
%endmacro

section .data readable writeable

; usual vtables of ActiveScript (Windows Script Host)
%include "activscp.inc"

com_err db "Unable to initialize COM", 0
co_create_err db "Unable to get VBScript IActiveScript instance: CoCreateInstance failed", 0
queryint_err db "QueryInterface failed !", 0
error_title db "Error", 0
error_code dw __utf16__('Error code 0x%08X'), 0ah, 0dh,
		   dw __utf16__('Error: %s'), 0
u_errortitle dw __utf16__('Script runtime error'), 0
vbprog dw __utf16__('Set objShell = CreateObject("WScript.Shell")'), 0ah, 0dh,
	   dw __utf16__('objShell.Run "notepad"'), 0ah, 0dh
	   dw __utf16__('MsgBox "It works !"'), 0


DEFINE_GUID IID_IUnknown, 00000000h, 0000h, 0000h, 0C0h, 00h, 00h, 00h, 00h, 00h, 00h, 46h

DEFINE_GUID GUID_VBSCRIPT, 0B54F3741h, 5B07h, 11cfh, 0A4h, 0B0h, 00h, 0AAh, 00h, 4Ah, 55h, 0E8h

MyScriptSite:
	dd StubQryInterface ;QueryInterface
	dd OkStub ; AddRef
	dd OkStub ; Release
    dd StubLCID ; GetLCID
	dd GetItemInfoStub ; GetItemInfo
	dd Stub8 ; GetDocVersionString
	dd StubC ; OnScriptTerminate
	dd Stub8 ; OnStateChange
	dd ErrorProc ; OnScriptError
	dd OkStub ; OnEnterScript
	dd OkStub ; OnLeaveScript

MyScriptWnd:
	dd WndQueryInterface ; QueryInterface
	dd OkStub ; AddRef
	dd OkStub ; Release
	dd StubGetWindow ; GetWindow
	dd StubEnableModeless ; EnableModeless
MyObject:
	dd MyScriptSite
	dd MyScriptWnd
section .bss readable writeable

hActiveScript resd 1
hActiveScriptParse resd 1

section .text readable executable

; Compare GUIDs
CmpGUID:
	push ebp
	mov ebp, esp
	push esi
	push edi
	push ecx
	xor eax, eax
	mov ecx, 10h
	mov esi, dword[ebp+8]
	mov edi, dword[ebp+0ch]
	mov ecx, 4
	rep cmpsd
	jnz .end
	inc eax
	.end:
	pop ecx
	pop edi
	pop esi
	leave
	ret 8

; ===========================================
; |   Interfaces implementation functions   |
; ===========================================

; IActiveScriptSiteWindow implementation (required to have MsgBox)
; ----------------------------------------------------------------

; GetWindow stub
StubGetWindow:
	push ebp
	mov ebp, esp
	mov ebx, [ebp+0ch]
	;call GetDesktopWindow
	xor eax, eax
	mov dword[ebx], eax
	mov eax, S_OK
	leave
	ret 8

; EnableModeless stub
StubEnableModeless:
	mov eax, S_OK
	ret 8

%define pThis 8
%define riid 0ch
%define ppv 10h
WndQueryInterface:
	push ebp
	mov ebp, esp
	push ebx
	push dword[ebp+riid]
	push IID_IActiveScriptSiteWindow
	call CmpGUID
	test eax, eax
	jz .not_found
	; returns our object
	mov eax, [ebp+pThis]
	mov ebx, [ebp+ppv]
	mov dword[ebx], eax
	mov eax, S_OK
	jmp .end
  .not_found:
	mov ebx, [ebp+ppv]
	mov dword[ebx], 0
	mov eax, E_NOINTERFACE
  .end:
	pop ebx
	leave
	ret 0ch

; IActiveScriptSite implementation
; --------------------------------

; Script error handler (doesn't do really something interesting)
ErrorProc:
	push ebp
	mov ebp, esp
	sub esp, 200h
	mov eax, [ebp+0ch] ; Grab the IActiveError object
	lea ebx, [ebp-104h] 
	push ebx ; Loads our buffer
	push eax
	mov ebx, [eax]
	call [ebx+0Ch] ; GetExceptionInfo
	
	push dword[ebp-0FCh] ; push error string
	push dword[ebp-104h] ; push error code
	push error_code
	lea ebx, [ebp-200h]
	push ebx
	call wsprintfW ; don't give a fuck about BoFs, it's just a test
	
	; Print error message
	lea ebx, [ebp-200h]
	push MB_ICONERROR
	push u_errortitle
	push ebx
	push 0
	call MessageBoxW
	leave
	ret 8

; QueryInterface	
StubQryInterface:
	push ebp
	mov ebp, esp
	push ebx
	push dword[ebp+riid]
	push IID_IActiveScriptSite
	call CmpGUID
	test eax, eax
	jz .check2 ; jumps if riid != IActiveScriptSite
  .return_this:
	mov eax, [ebp+pThis]
	mov ebx, [ebp+ppv]
	mov dword[ebx], eax
	mov eax, S_OK
	jmp .end
  .check2:
	push dword[ebp+riid]
	push IID_IUnknown 
	call CmpGUID
	test eax, eax
	jnz .return_this ; jumps if riid = IUnknown (returns the object)
	push dword[ebp+riid]
	push IID_IActiveScriptSiteWindow
	call CmpGUID
	test eax, eax
	jz .no_interface ; GTFO if riid != IActiveScriptWindow
	; Gets IActiveScriptWindow object
	mov eax, [ebp+pThis]
	add eax, 4
	mov ebx, [ebp+ppv]
	mov dword[ebx], eax
	mov eax, S_OK
	jmp .end
  .no_interface:
	; Called when there isn't any interface that match handled ones
	mov ebx, [ebp+ppv]
	mov dword[ebx], 0
	mov eax, E_NOINTERFACE
  .end:
	pop ebx
	leave
	ret 0ch

;GetItemInfo
GetItemInfoStub:
	push ebp
	mov ebp, esp
	mov eax, [ebp+10]
	and eax, 1
	jnz next
	mov eax, [ebp+14h]
	mov dword[eax], 0
	next:
	mov eax, [ebp+10]
	and eax, 2
	jnz fin
	mov eax, [ebp+18h]
	mov dword[eax], 0
	fin:
	mov eax, TYPE_E_ELEMENTNOTFOUND
	leave
	ret 14h

; Return the default LCID
StubLCID:
	mov dword [ebp+0ch], 400h
	mov eax, 0
	ret 8

; Common stubs (for lazy ppl)
; ---------------------------

; Always return "S_OK"
OkStub:
	mov eax, S_OK
	ret 4

; "Not implemented stubs"
Stub8:
	mov eax, E_NOTIMPL
	ret 8

StubC:
	mov eax, E_NOTIMPL
	ret 0ch

; =================================
; |       Main program :D         |
; ================================= 

_start:
	push ebp
	mov ebp, esp
	; Initialize COM
	push 0
	call CoInitialize
	cmp eax, 1
	jnz .com_success
	; COM initialization failed
	ErrMsg com_err
	jmp .gtfo
	
  .com_success:
	; Create VBScript object
	push hActiveScript ; our object which implement IActiveScript
	push IID_IActiveScript ; IID to get
	push 17h ; CLSCTX_ALL
	push 0
	push GUID_VBSCRIPT ; GUID of vbscript.dll DLL
	call CoCreateInstance
	test eax, eax
	jz .cominit_success
	ErrMsg co_create_err
	jmp .gtfo

  .cominit_success:
	; Got our VBScript object
	push hActiveScriptParse ; pointer to interface we'll get
	push IID_IActiveScriptParse ; IID to query
	mov eax, [hActiveScript] ; get object
	push eax ;lpThis
	mov ebx, [eax] ; ebx contains the vtable of COM object
	call [ebx + IUnknownVtbl.QueryInterface]
	jz .got_parser
	ErrMsg queryint_err
	jmp .gtfo
	
  .got_parser:
	; Got our IActiveScriptParse. Let's initialize stuff
	mov eax, [hActiveScriptParse]
	push eax ; lpThis
	mov ebx, [eax] ; get VTable
	call [ebx + IActiveScriptParseVtbl.InitNew] ; init stuff
	jz .initialized
	ErrMsg com_err
	jmp .gtfo
  .initialized:
    
	; Set our ScriptSite
	push MyObject ; our implementation of IActiveScriptSite (mainly stub functions)
	mov eax, [hActiveScript] 
	push eax ; pThis
	mov ebx, [eax]
	call [ebx + IActiveScriptVtbl.SetScriptSite] ; call our magic function
	jz .land_of_the_w00t
	ErrMsg com_err
	jmp .gtfo
  .land_of_the_w00t:
	; We succeded all initializations before
	; Let's parse the script now :)
	push 0
	push 0
	push 0
	push 0
	push 0
	push 0
	push 0
	push 0
	push vbprog ; pointer to program string to exec
	mov eax, [hActiveScriptParse]
	push eax ; pThis
	mov ebx, [eax]
	call [ebx + IActiveScriptParseVtbl.ParseScriptText]
	
	push 2 ; SCRIPTSATE_CONNECTED (launchs script execution)
	mov eax, [hActiveScript]
	push eax ; pThis
	mov ebx, [eax]
	call [ebx + IActiveScriptVtbl.SetScriptState] ; sets script state
	
	; Cleanups script parser
	mov eax, [hActiveScriptParse]
	push eax
	mov ebx, [eax]
	call [ebx + IUnknownVtbl.Release]
	
	; Cleanups script engine
	mov eax, [hActiveScript]
	push eax
	mov ebx, [eax]
	call [ebx + IUnknownVtbl.Release]
	
  .gtfo:
	push 0
	call ExitProcess
	leave
	ret
